package com.chinaitop.depot.basic.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.basic.mapper.BasicEnumMapper;
import com.chinaitop.depot.basic.mapper.BasicStorehouseMapper;
import com.chinaitop.depot.basic.mapper.BasicUnitAisleMapper;
import com.chinaitop.depot.basic.model.BasicEnum;
import com.chinaitop.depot.basic.model.BasicEnumExample;
import com.chinaitop.depot.basic.model.BasicStorehouse;
import com.chinaitop.depot.basic.model.BasicStorehouseExample;
import com.chinaitop.depot.basic.model.BasicUnitAisle;
import com.chinaitop.depot.basic.model.BasicUnitAisleExample;
import com.chinaitop.depot.basic.model.BasicUnitAisleExample.Criteria;
import com.chinaitop.depot.basic.service.BasicStorehouseService;
import com.chinaitop.depot.basic.service.BasicUnitAisleService;
import com.chinaitop.depot.utils.BusinessUtils;
import com.chinaitop.mq.dto.jkEnum;
import com.chinaitop.mq.pub.RecPublishService;
import com.chinaitop.utils.ParameterUtil;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigDecimal;
import java.util.*;

@Service
public class BasicUnitAisleServiceImpl implements BasicUnitAisleService {

    @Resource
    private BasicUnitAisleMapper basicUnitAisleMapper;

    @Resource
    private BasicStorehouseService basicStorehouseService;
    
    @Resource
    private BasicStorehouseMapper basicStorehouseMapper;
    
    @Resource
    private BasicEnumMapper enumMapper;
    
    @Resource
    private RecPublishService recPublishService;
    
    




    @Override
    public List<BasicUnitAisle> getList(Map<String, Object> map) throws Exception {
        return basicUnitAisleMapper.getUnitAisleList(map);
    }

    @Override
    public BasicUnitAisle findByUnitAisle(Integer id) {
        return basicUnitAisleMapper.findByUnitAisle(id);
    }

    @Override
    public Map<String, Object> saveOrUpdate(   HttpServletRequest request,String storehouseJson, String userInfo) throws Exception {
    	String czbz ="";
    	Map<String, Object> modelMap = new HashMap<String, Object>();
        JSONObject user = null;
        JSONObject org = null;
        Integer orgId = null;
        String userName = "";
        Map<String, Object> modelMap1 = new HashMap<String, Object>();

        if (null != userInfo && !"".equals(userInfo)) {
            user = JSONObject.parseObject(userInfo);
            orgId = Integer.parseInt(user.get("orgId") == null?"":user.get("orgId").toString());
            userName = user.get("username") == null?"":user.get("username").toString();
            modelMap1.put("orgId", orgId);
        }

        String ajbm ="";

        Date date = new Date();
        BasicStorehouse basicStorehouse =new BasicStorehouse();

        // JSON字符串转对象
        ObjectMapper mapper = new ObjectMapper();

        BasicUnitAisle basicUnitAisle = (BasicUnitAisle) mapper.readValue(storehouseJson, BasicUnitAisle.class);
		

        List<BasicUnitAisle> bUnitAisleTyajbmList = basicUnitAisleMapper.selectAllTyajbm(basicUnitAisle.getTyajbm());
        System.out.println("----------------------------");
        if(bUnitAisleTyajbmList != null && !bUnitAisleTyajbmList.isEmpty()&&bUnitAisleTyajbmList.size()>0){

			for (BasicUnitAisle basicUnitAisle1: bUnitAisleTyajbmList) {
				if(basicUnitAisle1.getId().equals(basicUnitAisle.getId())){
					if(basicUnitAisle.getBasicStorehouseId()!=null){
						basicStorehouse =  basicStorehouseService.findByPrimary1(basicUnitAisle.getBasicStorehouseId());
						modelMap1.put("basicStorehouseId",basicUnitAisle.getBasicStorehouseId());
						if(basicStorehouse!=null){
							basicUnitAisle.setCfbh(basicStorehouse.getCfbm());
							List<BasicUnitAisle> basicUnitAisleList = basicUnitAisleMapper.selectUnitAisleList1(modelMap1);
							if(basicUnitAisleList.size()==0){
								if(basicStorehouse.getCfbm()!=null){
									ajbm = BusinessUtils.setBZajbm(basicStorehouse.getCfbm(), basicStorehouse.getStorehouseType()+"", "0");
									basicUnitAisle.setAjdh(ajbm);
								}else {
									modelMap.put("status", "errors");
									return modelMap;
								}


							} else {


								// 获取原始字符串
								String ajdhValue = basicUnitAisleMapper.selectUnitAisleList1(modelMap1).get(0).getAjdh();


								// 使用正则表达式提取后三位数字
								Pattern pattern = Pattern.compile("(\\d{3})$");
								Matcher matcher = pattern.matcher(ajdhValue);
								if (matcher.find()) {
									String lastThreeDigits = matcher.group(1);


									// 将后三位数字转换为整数并加1
									int incrementedValue = Integer.parseInt(lastThreeDigits) + 1;

									// 将加1后的整数转换回三位数字字符串，保持前导零
									String incrementedDigits = String.format("%03d", incrementedValue);


									// 将原字符串的后三位替换为加1后的三位数字
									ajbm = ajdhValue.replaceFirst(pattern.pattern(), incrementedDigits);

									// 使用新的字符串进行后续操作（如保存到数据库等）
									basicUnitAisle.setAjdh(ajbm);
								}
							}
						}

					}

					if (basicUnitAisle.getId() == null) {
						czbz = "i";
						basicUnitAisle.setOrgId(orgId);
						basicUnitAisle.setCreatename(userName);
						basicUnitAisle.setCreatedate(date);
						basicUnitAisle.setUpdatename(userName);
						basicUnitAisle.setUpdatedate(date);
						basicUnitAisle.setCzbz("i");
						basicUnitAisle.setZhgxsj(date);
						basicUnitAisleMapper.insert(basicUnitAisle);
					} else {
						czbz = "u";
						basicUnitAisle.setUpdatename(userName);
						basicUnitAisle.setUpdatedate(date);
						basicUnitAisle.setZhgxsj(date);
						basicUnitAisle.setCzbz("u");
						basicUnitAisleMapper.updateByPrimaryKey(basicUnitAisle);
					}


				}else{
				modelMap.put("status", "errors");
				modelMap.put("msg","统一廒间编码"+ basicUnitAisle.getTyajbm()+"已存在,请勿重复添加！");
				return modelMap;
				}
				
			}
//

        }else{
            if(basicUnitAisle.getBasicStorehouseId()!=null){
				basicStorehouse =  basicStorehouseService.findByPrimary1(basicUnitAisle.getBasicStorehouseId());
				modelMap1.put("basicStorehouseId",basicUnitAisle.getBasicStorehouseId());
				if(basicStorehouse!=null){
					basicUnitAisle.setCfbh(basicStorehouse.getCfbm());
					List<BasicUnitAisle> basicUnitAisleList = basicUnitAisleMapper.selectUnitAisleList1(modelMap1);
					if(basicUnitAisleList.size()==0){
						if(basicStorehouse.getCfbm()!=null){
							ajbm = BusinessUtils.setBZajbm(basicStorehouse.getCfbm(), basicStorehouse.getStorehouseType()+"", "0");
							basicUnitAisle.setAjdh(ajbm);
						}else {
							modelMap.put("status", "errors");
							return modelMap;
						}


					} else {


						// 获取原始字符串
						String ajdhValue = basicUnitAisleMapper.selectUnitAisleList1(modelMap1).get(0).getAjdh();


						// 使用正则表达式提取后三位数字
						Pattern pattern = Pattern.compile("(\\d{3})$");
						Matcher matcher = pattern.matcher(ajdhValue);
						if (matcher.find()) {
							String lastThreeDigits = matcher.group(1);


							// 将后三位数字转换为整数并加1
							int incrementedValue = Integer.parseInt(lastThreeDigits) + 1;

							// 将加1后的整数转换回三位数字字符串，保持前导零
							String incrementedDigits = String.format("%03d", incrementedValue);


							// 将原字符串的后三位替换为加1后的三位数字
							ajbm = ajdhValue.replaceFirst(pattern.pattern(), incrementedDigits);

							// 使用新的字符串进行后续操作（如保存到数据库等）
							basicUnitAisle.setAjdh(ajbm);
						}
					}
				}

			}

            if (basicUnitAisle.getId() == null) {
				czbz = "i";
				basicUnitAisle.setOrgId(orgId);
                basicUnitAisle.setCreatename(userName);
                basicUnitAisle.setCreatedate(date);
                basicUnitAisle.setUpdatename(userName);
                basicUnitAisle.setUpdatedate(date);
                basicUnitAisle.setCzbz("i");
                basicUnitAisle.setZhgxsj(date);
                basicUnitAisleMapper.insert(basicUnitAisle);
            } else {
				czbz = "u";
                basicUnitAisle.setUpdatename(userName);
                basicUnitAisle.setUpdatedate(date);
                basicUnitAisle.setZhgxsj(date);
                basicUnitAisle.setCzbz("u");
                basicUnitAisleMapper.updateByPrimaryKey(basicUnitAisle);
            }
        }
        
        /**
         * 国家局
         */
    
//        Map<String, Object>  gjjMap = basicUnitAisleMapper.getAjGjjDate(basicUnitAisle.getId());
//		gjjMap.put("is_upload", 0);
//		String tableName = "ODS_UP_AJXXJK";
//		recPublishService.sendMessage(gjjMap,tableName,basicUnitAisle.getOrgId());
		
		recPublishService.sendMessage(czbz,jkEnum.aj.getTableName(),basicUnitAisle.getId()+"",basicUnitAisle.getOrgId());
        modelMap.put("status", "success");

        return modelMap;
    }


    public void updateBasicStorehouse(BasicUnitAisle basicUnitAisle){
        basicUnitAisleMapper.updateByPrimaryKey(basicUnitAisle);
    }

    
	@Override
	public Map<String, Object> getAisleInfo(Integer unitId, Integer storehouseId) {
		// TODO Auto-generated method stub

		/* 返回大对象 */
		Map<String, Object> map = new HashMap<String, Object>();

		/* 设置货位的按ID转化对象 */
		List<BasicUnitAisle> aislelist = getAisleList(unitId, null);  //获取当前库所有ao j
		
		Map<Integer, Object> aisleMap = new HashMap<Integer, Object>();
		if (null != aislelist && aislelist.size() != 0) {
			for (BasicUnitAisle aisle : aislelist) {
				aisleMap.put(aisle.getId(), aisle);
			}
		} else {
			aislelist = new ArrayList<BasicUnitAisle>();
		}
		map.put("aisle", aisleMap); // 数据列表页面转换对象

		/* 获取有效的货位下拉列表 */
		List<BasicUnitAisle> list = getAisleList(unitId, storehouseId); //获取库点下的某个仓房中的的ao j
		map.put("aisleList", list); //ao j下拉列表集合

		return map;
	}
	
	/**
	 * 按条件查询廒间数据
	 * 
	 * @param orgId 单位ID
	 * @param houseId 仓房ID
	 * @param libraryType 是否代储
	 * @param delFlag 是否在用
	 * @return
	 */
	@SuppressWarnings("all")
	private List<BasicUnitAisle> getAisleList(Integer orgId, Integer houseId) {
		List<BasicUnitAisle> list = null;
		BasicUnitAisleExample example = new BasicUnitAisleExample();
		Criteria criteria = example.createCriteria();
		try {
			if (null != orgId) {
				criteria.andOrgIdEqualTo(orgId);
			}
			if (null != houseId) {
				criteria.andBasicStorehouseIdEqualTo(houseId);
			}
			criteria.andCzbzNotEqualTo("d");
			example.setOrderByClause("id ASC");
			list = basicUnitAisleMapper.selectByExample(example);
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			return list;
		}
	}

	@Override
	public String importData(List<List<String>> list, JSONObject user) {
		// TODO Auto-generated method stub
		Integer orgId =0;
		String orgName = "";
		String username = "";
		if (null != user) {
			orgId = Integer.parseInt(user.get("orgId") == null?"":user.get("orgId").toString());
			orgName = user.get("orgName") == null?"":user.get("orgName").toString();
			username = user.get("username") == null?"":user.get("username").toString();
		}
		Date date = new Date();
		String ajbm ="";
		String msg = "";//消息
		boolean value_flag = false;
		int len = 0;//长度
		//根据字典名字查询字典编号
		BasicEnumExample enumExample = new BasicEnumExample();
		BasicEnumExample.Criteria Criteria = enumExample.createCriteria();
		List<BasicEnum> basicEnums;
		

		BasicUnitAisle unitAisle = new BasicUnitAisle();

		BasicStorehouseExample exampleStorehouse = new BasicStorehouseExample();
		BasicStorehouseExample.Criteria criteriaStoreHouse = exampleStorehouse.createCriteria();
		List<BasicStorehouse> storehouseList;
		Map<String, Object> modelMap1 = new HashMap<String, Object>();
		for (int i = 0; i < list.size(); i++) {
			List<String> revList = list.get(i);

			for (int j = 0; j < revList.size(); j++) {
				switch(j) {
					case 0://统一廒间编码
						if (revList.get(j).length()>0) {
							len = revList.get(j).length();
							if (len > 26) {
								msg = "第 "+(i+1)+" 行第 1 列的值的长度不能超过26！";
								return msg;
							}
				List<BasicUnitAisle> bUnitAisleTyajbmList = basicUnitAisleMapper.selectAllTyajbm(revList.get(j));
					if(bUnitAisleTyajbmList.size()>0){
						msg="统一廒间编码"+ revList.get(j)+"已存在,请勿重复添加！";
					}else{
						unitAisle.setTyajbm(revList.get(j));
					}

						}
						break;
					case 1://廒间名称
						if (unitAisle != null && revList.get(j).length()>0) {
							len = revList.get(j).length();
							if (len > 30) {
								msg = "第 "+(i+1)+" 行廒间名称的值的长度不能超过30！";
								return msg;
							}
							unitAisle.setAjmc(revList.get(j));
						}
						break;
					case 2://仓房名称
						if (unitAisle != null && revList.get(j).length()>0) {
							len = revList.get(j).length();
							exampleStorehouse.clear();
							criteriaStoreHouse = exampleStorehouse.createCriteria();
							criteriaStoreHouse.andStorehouseNameEqualTo(revList.get(j));
							criteriaStoreHouse.andOrgIdEqualTo(orgId);
							storehouseList = basicStorehouseMapper.selectByExample(exampleStorehouse);
							if(storehouseList.size()>0){
								unitAisle.setBasicStorehouseId(storehouseList.get(0).getStorehouseId());//仓房id

								modelMap1.put("basicStorehouseId",storehouseList.get(0).getStorehouseId());
								List<BasicUnitAisle> basicUnitAisleList = basicUnitAisleMapper.selectUnitAisleList1(modelMap1);
								unitAisle.setCfbh(storehouseList.get(0).getCfbm());//仓房编码
								if(basicUnitAisleList.size()==0){
									if (!"".equals(storehouseList.get(0).getCfbm())) {

										 ajbm = BusinessUtils.setBZajbm(storehouseList.get(0).getCfbm(), storehouseList.get(0).getStorehouseType()+"", "0");
										unitAisle.setAjdh(ajbm.trim());
									}
								} else {


									// 获取原始字符串
									String ajdhValue = basicUnitAisleMapper.selectUnitAisleList1(modelMap1).get(0).getAjdh();


									// 使用正则表达式提取后三位数字
									Pattern pattern = Pattern.compile("(\\d{3})$");
									Matcher matcher = pattern.matcher(ajdhValue);
									if (matcher.find()) {
										String lastThreeDigits = matcher.group(1);


										// 将后三位数字转换为整数并加1
										int incrementedValue = Integer.parseInt(lastThreeDigits) + 1;

										// 将加1后的整数转换回三位数字字符串，保持前导零
										String incrementedDigits = String.format("%03d", incrementedValue);


										// 将原字符串的后三位替换为加1后的三位数字
										ajbm = ajdhValue.replaceFirst(pattern.pattern(), incrementedDigits);

										// 使用新的字符串进行后续操作（如保存到数据库等）
										unitAisle.setAjdh(ajbm);
									}
								}

							}else{
								msg = "第 "+(i+1)+" 行仓房名称有误,该库点没有此名称！";
								return msg;
							}
						}
						break;
					case 3://廒间长（米）
						if (ParameterUtil.isnotnull(revList.get(j)) && revList.get(j).length()>0) {
							// 创建正则表达式模式
							String pattern = "[0-9]+(\\.[0-9]+)?"; // 匹配整数或小数

							// 使用Pattern和Matcher进行匹配
							value_flag = Pattern.matches(pattern, revList.get(j));
							if (!value_flag) {
								msg = "第 "+(i+1)+" 行的第 4 列的值只能是数字或小数！";
								return msg;
							}
							len = revList.get(j).length();
							if (len > 30) {
								msg = "第 "+(i+1)+" 行第 4 列的值的长度不能超过30！";
								return msg;
							}
							BigDecimal bd = new BigDecimal(revList.get(j));
							unitAisle.setAjcd(bd);
						}
						break;
					case 4://廒间宽(米)
						if (ParameterUtil.isnotnull(revList.get(j)) && revList.get(j).length()>0) {
							// 创建正则表达式模式
							String pattern = "[0-9]+(\\.[0-9]+)?"; // 匹配整数或小数

							// 使用Pattern和Matcher进行匹配
							value_flag = Pattern.matches(pattern, revList.get(j));

							if (!value_flag) {
								msg = "第 "+(i+1)+" 行的第 5 列的值只能是数字或小数！";
								return msg;
							}
							len = revList.get(j).length();
							if (len > 30) {
								msg = "第 "+(i+1)+" 行第 5 列的值的长度不能超过30！";
								return msg;
							}
							BigDecimal bd = new BigDecimal(revList.get(j));
							unitAisle.setAjkd(bd);
						}
						break;
					case 5://廒间高(米)
						if (ParameterUtil.isnotnull(revList.get(j)) && revList.get(j).length()>0) {
							value_flag = revList.get(j).matches("[0-9]+");
							if (!value_flag) {
								msg = "第 "+(i+1)+" 行的第 6 列的值只能是数字！";
								return msg;
							}
							len = revList.get(j).length();
							if (len > 30) {
								msg = "第 "+(i+1)+" 行第 6 列的值的长度不能超过30！";
								return msg;
							}
							BigDecimal bd = new BigDecimal(revList.get(j));
							unitAisle.setAjgd(bd);
						}
						break;
					case 6://廒间设计仓容（吨）
						if (ParameterUtil.isnotnull(revList.get(j)) && unitAisle != null && revList.get(j).length()>0) {
							len = revList.get(j).length();
							Pattern p = Pattern.compile("^(([1-9]{1}\\d*)|([0]{1}))(\\.(\\d){0,2})?$");
							Matcher m = p.matcher(revList.get(j));
							boolean flag = m.matches();
							if (!flag || len > 7) {
								msg = "第"+(i+1)+"行，廒间设计仓容的长度包括小数位不能大于7位，小数位最多2位，";
								return msg;
							}
							BigDecimal bd = new BigDecimal(revList.get(j));
							unitAisle.setAjsjcr(bd);
						}
						break;
					case 7://廒间启用日期
						if (ParameterUtil.isnotnull(revList.get(j)) && unitAisle != null) {
							if(!ParameterUtil.stringIsTimeDate(revList.get(j))){
								msg = "第 "+(i+1)+" 行第 8 列的值不属于时间，请确认后再提交！";
								return msg;
							}
							unitAisle.setAjqyrq(ParameterUtil.string2date(revList.get(j)));
						}
						break;
					case 8://ao j状态
						if (ParameterUtil.isnotnull(revList.get(j)) && revList.get(j).length()>0) {
							Integer ajzt =0;
							if(revList.get(j).equals("完好")){
								ajzt=1;
							}else if(revList.get(j).equals("需小修")){
								ajzt=2;
							}else if(revList.get(j).equals("需大修")){
								ajzt=3;
							}else if(revList.get(j).equals("待报废")){
								ajzt=4;
							}else if(revList.get(j).equals("待拆除")){
								ajzt=5;
							}else if(revList.get(j).equals("死角仓")){
								ajzt=6;
							}else if(revList.get(j).equals("其他")){
								ajzt=9;
							}

								unitAisle.setAjzt(ajzt);
						}
					/*case 5://建造日期
						if (ParameterUtil.isnotnull(revList.get(j)) && tank != null) {
							boolean convertSuccess = true;
                        	SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
                        	try {
                        		// 设置lenient为false. 否则SimpleDateFormat会比较宽松地验证日期，比如2007/02/29会被接受，并转换成2007/03/01
                        		format.setLenient(false);
                        		format.parse(revList.get(j));
                        	} catch (Exception e) {
                        		// 如果throw java.text.ParseException或者NullPointerException，就说明格式不对
                        		convertSuccess = false;
                        	} 
                        	if (!convertSuccess) {
                        		msg = "第"+(i+1)+"行，建造日期的格式不正确，正确格式如：2020-01-01，";
                        		return msg;
                        	}
							tank.setBuilddate(ParameterUtil.string2date(revList.get(j)));
						}*/
						if (unitAisle != null) {
							unitAisle.setOrgId(orgId);
							unitAisle.setCreatedate(date);
							unitAisle.setZhgxsj(date);
							unitAisle.setUpdatedate(date);
							unitAisle.setCzbz("i");
							basicUnitAisleMapper.insert(unitAisle);
							msg="导入成功";
						}
						break;
					default :
						break;
				}

			}

		}
		return msg;
    
	}

	@Override
	public void updateDelFlagById(Integer storehouseId) {
		// TODO Auto-generated method stub
		basicUnitAisleMapper.delFlagByCfId(storehouseId);
	}

	@Override
	public Map<String, Object> getAjGjjDate(Integer id) {
		// TODO Auto-generated method stub
		return basicUnitAisleMapper.getAjGjjDate(id);
	}

	
}
