package com.chinaitop.mq.sub;

import com.chinaitop.depot.common.util.SecureMngr;
import com.chinaitop.depot.gjjsj.mapper.GjjMapper;
import com.chinaitop.mq.utils.FileUtil;
import com.chinaitop.mq.dto.BaseDTO;
import com.chinaitop.mq.dto.RecevieDTO;
import com.chinaitop.mq.dto.TestDTO;
import com.chinaitop.mq.dto.UploadDTO;
import com.chinaitop.mq.dto.jkEnum;
import com.chinaitop.mq.utils.JsonUtils;
import com.google.gson.Gson;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;

import javax.annotation.Resource;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.data.redis.connection.Message;
import org.springframework.data.redis.connection.MessageListener;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

/**
 * 我的订阅
 *
 * @author ybw
 * @version V1.0
 * @className MySub
 * @date 2024/5/9
 **/
@Component
public class MyMessageListener implements MessageListener {
    private Log log = LogFactory.getLog(this.getClass());

    @Resource
    private RestTemplate restTemplate;

    @Bean
    public RestTemplate restTemplate() {
        return new RestTemplate();
    }
    
    
    @Resource
    private GjjMapper gjjMapper;
    
    @Value("${jsgjjsjUrl}")
    private String jsgjjsjUrl;
    
    /*@Override
    public void onMessage(Message message, byte[] bytes) {
    	
    	//1、转换为对象
    	UploadDTO uploadDTO = (UploadDTO)JsonUtils.mqMessageToObj1(message.getBody());
    	
    	*//**
         * restTemplate调用
         *//*
        //String url = "http://localhost:49183/service/API/CJCURE/DateUpload";//
        // 发送post请求，并打印结果，以String类型接收响应结果JSON字符串
        String result = (String) restTemplate.postForObject(jsgjjsjUrl, uploadDTO, Object.class);
        
        
    }*/
    
    @Override
    public void  onMessage(Message message, byte[] bytes) {
    	
    	//1、转换为对象
        byte[] body = message.getBody();
        if (body.length > 0) {
            RecevieDTO recevieDTO = JsonUtils.mqMessageToObj1(message.getBody());
            if ((recevieDTO) != null) {
                this.getDate(recevieDTO);
            }
        }
        
    }
    
    
    private synchronized void getDate(RecevieDTO recevieDTO){
    	
    	/**
    	 * 拼接业务数据
    	 */
    	String czbz = recevieDTO.getCzbz();
    	Integer orgId = recevieDTO.getOrgId();
    	String tableName = recevieDTO.getTableName();
    	String ywId = recevieDTO.getYwId();
    	
    	List<Map<String, Object>> list = new ArrayList<Map<String, Object>>();
		Map<String,List<Map<String, Object>>> map1 = new HashMap<String,List<Map<String, Object>>>();
		List<Map<String,List<Map<String, Object>>>> ywData = new ArrayList<Map<String,List<Map<String, Object>>>>();
		
		Map<String, Object> pjsjmap = new HashMap<>();
    	if(tableName != null && tableName != ""){
    	    if(tableName.equals(jkEnum.kq.getTableName())){//库区信息
    			
    			pjsjmap = gjjMapper.getKqGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.cf.getTableName())){//仓房信息
    			log.info("ywId:----------------------------{}"+ywId);
    			
    			pjsjmap = gjjMapper.getCfGjjDate(ywId);
    			log.info("pjsjmap:----------------------------{}"+pjsjmap);
    			
    		}else if(tableName.equals(jkEnum.aj.getTableName())){//厫间信息
    			
    			pjsjmap = gjjMapper.getAjGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.hw.getTableName())){//货位信息
    			
    			pjsjmap = gjjMapper.getHwGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.yg.getTableName())){//油罐信息
    			
    			pjsjmap = gjjMapper.getYgGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.sb.getTableName())){//设备信息
    			
    			pjsjmap = gjjMapper.getSbGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.yj.getTableName())){//药剂信息
    			
    			pjsjmap = gjjMapper.getYjGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.kqtcfdwbz.getTableName())){//库区图仓房点位标注
    			
    			pjsjmap = gjjMapper.getKqtcfdwbzGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.kqtspjkdwbz.getTableName())){//库区图视频监控点位标注信息
    			
    			pjsjmap = gjjMapper.getSpjkdwGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.ry.getTableName())){//人员信息
    			
    			pjsjmap = gjjMapper.getRyGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.ht.getTableName())){//合同信息
    			
    			pjsjmap = gjjMapper.getHtGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.ht.getTableName())){//客户信息
    			
    			pjsjmap = gjjMapper.getKhxxGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.aq.getTableName())){//安全管理
    			
    			pjsjmap = gjjMapper.getAqglGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.wsd.getTableName())){//温湿度
    			
    			pjsjmap = gjjMapper.getWsdGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.tf.getTableName())){//通风
    			
    			pjsjmap = gjjMapper.getTfGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.xz.getTableName())){//熏蒸
    			
    			pjsjmap = gjjMapper.getXzGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.wgyj.getTableName())){//违规预警信息
    			
    			pjsjmap = gjjMapper.getWgyjGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.cbgm.getTableName())){//储备规模
    			
    			pjsjmap = gjjMapper.getWgyjGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.zj.getTableName())){//质检
    			
    			pjsjmap = gjjMapper.getZjGjjDate(ywId);
    			
    		}else if(tableName.equals(jkEnum.hcjc.getTableName())){//害虫检测
    			
    		}else if(tableName.equals(jkEnum.wj.getTableName())){//文件信息
    			
    			pjsjmap = gjjMapper.getWjGjjData(ywId);
    			
    			String url = (String) pjsjmap.get("tpdz");
    			if(null != url && "" != url && url.length()>0){
    				String wjl = FileUtil.getBase64Content(url);
    				pjsjmap.put("wjl", wjl);
    			}else{
    				pjsjmap.put("wjl", "");
    			}
    			
    			pjsjmap.remove("tpdz");
    			
    		}else if(tableName.equals(jkEnum.cnsptx.getTableName())){//仓内视频图像信息
    			pjsjmap = gjjMapper.getCnsptxGjjData(ywId);
    			
    			String cntxdz = (String) pjsjmap.get("cntxdz");
    			String wjl = FileUtil.getBase64Content(cntxdz);
    			pjsjmap.put("cntxwjl", wjl);
    			
    			pjsjmap.remove("cntxdz");
    			
    		}
    		
    		if(!pjsjmap.isEmpty() && pjsjmap != null){
    			log.info("orgId:----------------------------{}"+orgId);

        		pjsjmap.put("DEP_KQDM", orgId);
    			log.info("pjsjmap:----------------------------{}"+pjsjmap);

        		pjsjmap.put("CZBZ", czbz);
        		
        		
        		list.add(pjsjmap);
        		map1.put(tableName, list);
        		ywData.add(map1);
        		
        		Gson Gson = new Gson();
        		String a = Gson.toJson(ywData);
        		//数据加密
                String bodyStr = null;
                
    			try {
    				bodyStr = SecureMngr.encryptByAES(SecureMngr.AES_KEY, a);
    				
    			} catch (Exception e) {
    				// TODO Auto-generated catch block
    				e.printStackTrace();
    			}
                
                LocalDateTime date = LocalDateTime.now();
                DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"); 
                String formattedDate = date.format(formatter).toString();
                
                UploadDTO sendData = new UploadDTO();
                sendData.setOrgNo(orgId+"");
                sendData.setBody(bodyStr);
                sendData.setSendTime(formattedDate);
                sendData.setId("9caaa29a-7297-4195-89ee-b7bbefccc9aa");
                sendData.setVer("1.0");
                
                
                /**
                 * restTemplate调用
                 */
                //String url = "http://localhost:49183/service/API/CJCURE/DateUpload";//
                // 发送post请求，并打印结果，以String类型接收响应结果JSON字符串
               restTemplate.postForObject(jsgjjsjUrl, sendData, Object.class);
    		}
			
            
    	}
    	
    }
    
    
    /**
     * 业务处理-测试
     *
     * @param baseDTO
     * @methodName: handle
     * @return: void
     * @author: ybw
     * @date: 2024/5/9
     **/
    private void handleTest(BaseDTO<TestDTO> baseDTO) {
        switch (baseDTO.getBizOperateType()) {
            case INSERT:
                log.info("新增");
                break;
            case UPDATE:
                log.info("修改");
                break;
            case DELETE:
                log.info("删除");
                break;
            default:
                log.info("其他");
                break;
        }
    }

	
}
