package com.chinaitop.mq.pub;

import com.alibaba.fastjson.JSON;
import com.chinaitop.DepotBasicApplication;
import com.chinaitop.mq.constant.BizOperateType;
import com.chinaitop.mq.constant.BizType;
import com.chinaitop.mq.constant.TopicConstant;
import com.chinaitop.mq.dto.BaseDTO;
import com.chinaitop.mq.dto.TestDTO;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;
import java.util.concurrent.TimeUnit;


/**
 * @author ybw
 * @version V1.0
 * @className PublishServiceTest
 * @date 2024/5/9
 **/
@RunWith(SpringRunner.class)
@SpringBootTest(classes = DepotBasicApplication.class)
public class PublishServiceTest {

    @Resource
    private PublishService publishService;

    /**
     * 发送消息
     *
     * @methodName: sendMessage
     * @return: void
     * @author: ybw
     * @date: 2024/5/9
     **/
    @Test
    public void sendMessage() throws InterruptedException {
        TestDTO testDTO = new TestDTO();
        testDTO.setAge(18);
        testDTO.setName("ybw");

        BaseDTO<TestDTO> baseDTO = new BaseDTO(BizType.TEST, BizOperateType.INSERT, testDTO);

        publishService.sendMessage(TopicConstant.DEPOT_TOPIC_NAME, JSON.toJSONString(baseDTO));
        TimeUnit.DAYS.sleep(1);
    }
}